Index: branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionConstraintView.Designer.cs
===================================================================
--- branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionConstraintView.Designer.cs	(revision 6784)
+++ 	(revision )
@@ -1,143 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Optimization.Views {
-  partial class RunCollectionConstraintView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.lblConstrainedMember = new System.Windows.Forms.Label();
-      this.lblComparisonOperation = new System.Windows.Forms.Label();
-      this.lblCompareValue = new System.Windows.Forms.Label();
-      this.cmbConstraintOperation = new System.Windows.Forms.ComboBox();
-      this.chbActive = new System.Windows.Forms.CheckBox();
-      this.cmbConstraintColumn = new System.Windows.Forms.ComboBox();
-      this.SuspendLayout();
-      // 
-      // lblConstrainedMember
-      // 
-      this.lblConstrainedMember.AutoSize = true;
-      this.lblConstrainedMember.Location = new System.Drawing.Point(3, 6);
-      this.lblConstrainedMember.Name = "lblConstrainedMember";
-      this.lblConstrainedMember.Size = new System.Drawing.Size(107, 13);
-      this.lblConstrainedMember.TabIndex = 0;
-      this.lblConstrainedMember.Text = "Constrained Member:";
-      // 
-      // lblComparisonOperation
-      // 
-      this.lblComparisonOperation.AutoSize = true;
-      this.lblComparisonOperation.Location = new System.Drawing.Point(3, 32);
-      this.lblComparisonOperation.Name = "lblComparisonOperation";
-      this.lblComparisonOperation.Size = new System.Drawing.Size(106, 13);
-      this.lblComparisonOperation.TabIndex = 1;
-      this.lblComparisonOperation.Text = "Constraint Operation:";
-      // 
-      // lblCompareValue
-      // 
-      this.lblCompareValue.AutoSize = true;
-      this.lblCompareValue.Location = new System.Drawing.Point(3, 59);
-      this.lblCompareValue.Name = "lblCompareValue";
-      this.lblCompareValue.Size = new System.Drawing.Size(83, 13);
-      this.lblCompareValue.TabIndex = 2;
-      this.lblCompareValue.Text = "Constraint Data:";
-      // 
-      // cmbConstraintOperation
-      // 
-      this.cmbConstraintOperation.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.cmbConstraintOperation.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.cmbConstraintOperation.FormattingEnabled = true;
-      this.cmbConstraintOperation.Location = new System.Drawing.Point(127, 29);
-      this.cmbConstraintOperation.Name = "cmbConstraintOperation";
-      this.cmbConstraintOperation.Size = new System.Drawing.Size(246, 21);
-      this.cmbConstraintOperation.TabIndex = 4;
-      this.cmbConstraintOperation.SelectedIndexChanged += new System.EventHandler(this.cmbComparisonOperation_SelectedIndexChanged);
-      // 
-      // chbActive
-      // 
-      this.chbActive.AutoSize = true;
-      this.chbActive.Location = new System.Drawing.Point(127, 82);
-      this.chbActive.Name = "chbActive";
-      this.chbActive.Size = new System.Drawing.Size(56, 17);
-      this.chbActive.TabIndex = 7;
-      this.chbActive.Text = "Active";
-      this.chbActive.UseVisualStyleBackColor = true;
-      this.chbActive.CheckedChanged += new System.EventHandler(this.chbActive_CheckedChanged);
-      // 
-      // cmbConstraintColumn
-      // 
-      this.cmbConstraintColumn.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.cmbConstraintColumn.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.cmbConstraintColumn.FormattingEnabled = true;
-      this.cmbConstraintColumn.Location = new System.Drawing.Point(127, 3);
-      this.cmbConstraintColumn.Name = "cmbConstraintColumn";
-      this.cmbConstraintColumn.Size = new System.Drawing.Size(246, 21);
-      this.cmbConstraintColumn.TabIndex = 8;
-      this.cmbConstraintColumn.SelectedIndexChanged += new System.EventHandler(this.cmbConstraintColumn_SelectedIndexChanged);
-      // 
-      // RunCollectionConstraintView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.cmbConstraintColumn);
-      this.Controls.Add(this.chbActive);
-      this.Controls.Add(this.cmbConstraintOperation);
-      this.Controls.Add(this.lblCompareValue);
-      this.Controls.Add(this.lblComparisonOperation);
-      this.Controls.Add(this.lblConstrainedMember);
-      this.Name = "RunCollectionConstraintView";
-      this.Size = new System.Drawing.Size(376, 102);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label lblConstrainedMember;
-    private System.Windows.Forms.Label lblComparisonOperation;
-    private System.Windows.Forms.Label lblCompareValue;
-    private System.Windows.Forms.CheckBox chbActive;
-    protected System.Windows.Forms.ComboBox cmbConstraintColumn;
-    protected System.Windows.Forms.ComboBox cmbConstraintOperation;
-  }
-}
Index: branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionConstraintView.cs
===================================================================
--- branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionConstraintView.cs	(revision 6784)
+++ 	(revision )
@@ -1,125 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Linq;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Optimization.Views {
-  [Content(typeof(IRunCollectionConstraint))]
-  public partial class RunCollectionConstraintView : ItemView {
-    public RunCollectionConstraintView() {
-      InitializeComponent();
-    }
-
-    public new IRunCollectionConstraint Content {
-      get { return (IRunCollectionConstraint)base.Content; }
-      set { base.Content = value; }
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      cmbConstraintColumn.Items.Clear();
-      cmbConstraintOperation.Items.Clear();
-
-      if (Content != null) {
-        cmbConstraintOperation.Items.AddRange(Content.AllowedConstraintOperations.ToArray());
-        if (Content.ConstraintOperation != null)
-          cmbConstraintOperation.SelectedItem = Content.ConstraintOperation;
-        else if (cmbConstraintOperation.Items.Count != 0)
-          cmbConstraintOperation.SelectedIndex = 0;
-        UpdateColumnComboBox();
-        chbActive.Checked = Content.Active;
-        ReadOnly = Content.Active;
-      } else
-        chbActive.Checked = false;
-    }
-
-    protected virtual void UpdateColumnComboBox() {
-      this.cmbConstraintColumn.Items.Clear();
-      if (Content.ConstrainedValue != null) {
-        this.cmbConstraintColumn.Items.AddRange(((IStringConvertibleMatrix)Content.ConstrainedValue).ColumnNames.ToArray());
-        if (!string.IsNullOrEmpty(Content.ConstraintColumn))
-          this.cmbConstraintColumn.SelectedItem = Content.ConstraintColumn;
-      }
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      this.Content.ActiveChanged += new EventHandler(Content_ActiveChanged);
-      this.Content.ConstraintOperationChanged += new EventHandler(Content_ComparisonOperationChanged);
-      this.Content.ConstraintColumnChanged += new EventHandler(Content_ConstraintColumnChanged);
-      this.Content.ConstrainedValueChanged += new EventHandler(Content_ConstrainedValueChanged);
-    }
-
-    protected override void DeregisterContentEvents() {
-      base.DeregisterContentEvents();
-      this.Content.ActiveChanged -= new EventHandler(Content_ActiveChanged);
-      this.Content.ConstraintOperationChanged -= new EventHandler(Content_ComparisonOperationChanged);
-      this.Content.ConstraintColumnChanged -= new EventHandler(Content_ConstraintColumnChanged);
-      this.Content.ConstrainedValueChanged += new EventHandler(Content_ConstrainedValueChanged);
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      cmbConstraintColumn.Enabled = !this.ReadOnly && Content != null;
-      cmbConstraintOperation.Enabled = !this.ReadOnly && Content != null;
-      chbActive.Enabled = !this.Locked && Content != null;
-    }
-
-    protected virtual void Content_ConstrainedValueChanged(object sender, EventArgs e) {
-      this.UpdateColumnComboBox();
-    }
-
-    protected virtual void Content_ConstraintColumnChanged(object sender, EventArgs e) {
-      if (Content.ConstrainedValue != null) {
-        if (cmbConstraintColumn.SelectedItem.ToString() != Content.ConstraintColumn)
-          cmbConstraintColumn.SelectedItem = Content.ConstraintColumn;
-      }
-    }
-    private void cmbConstraintColumn_SelectedIndexChanged(object sender, EventArgs e) {
-      if (Content.ConstrainedValue != null) {
-        Content.ConstraintColumn = (string)cmbConstraintColumn.SelectedItem;
-      }
-    }
-
-    protected virtual void Content_ComparisonOperationChanged(object sender, EventArgs e) {
-      if (Content.ConstraintOperation != (ConstraintOperation)this.cmbConstraintOperation.SelectedItem)
-        this.cmbConstraintOperation.SelectedItem = Content.ConstraintOperation;
-    }
-    protected virtual void cmbComparisonOperation_SelectedIndexChanged(object sender, EventArgs e) {
-      Content.ConstraintOperation = (ConstraintOperation)this.cmbConstraintOperation.SelectedItem;
-    }
-
-    protected virtual void Content_ActiveChanged(object sender, EventArgs e) {
-      if (this.chbActive.Checked != Content.Active)
-        this.chbActive.Checked = Content.Active;
-      this.ReadOnly = Content.Active;
-    }
-    protected virtual void chbActive_CheckedChanged(object sender, EventArgs e) {
-      if (Content != null)
-        Content.Active = chbActive.Checked;
-    }
-  }
-}
Index: branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.Designer.cs
===================================================================
--- branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.Designer.cs	(revision 6784)
+++ 	(revision )
@@ -1,155 +1,0 @@
-﻿namespace HeuristicLab.Optimization.Views {
-  partial class RunCollectionModificationEvaluatorView {
-    /// <summary>
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary>
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Windows Form Designer generated code
-
-    /// <summary>
-    /// Required method for Designer support - do not modify
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.evaluateButton = new System.Windows.Forms.Button();
-      this.tabControl = new System.Windows.Forms.TabControl();
-      this.runsTabPage = new System.Windows.Forms.TabPage();
-      this.runCollectionViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.modifiersTabPage = new System.Windows.Forms.TabPage();
-      this.modifiersViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.tabControl.SuspendLayout();
-      this.runsTabPage.SuspendLayout();
-      this.modifiersTabPage.SuspendLayout();
-      this.SuspendLayout();
-      // 
-      // nameTextBox
-      // 
-      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      this.nameTextBox.Size = new System.Drawing.Size(419, 20);
-      // 
-      // infoLabel
-      // 
-      this.infoLabel.Location = new System.Drawing.Point(483, 3);
-      // 
-      // evaluateButton
-      // 
-      this.evaluateButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.evaluateButton.Location = new System.Drawing.Point(6, 266);
-      this.evaluateButton.Name = "evaluateButton";
-      this.evaluateButton.Size = new System.Drawing.Size(75, 23);
-      this.evaluateButton.TabIndex = 4;
-      this.evaluateButton.Text = "&Evaluate";
-      this.evaluateButton.UseVisualStyleBackColor = true;
-      this.evaluateButton.Click += new System.EventHandler(this.evaluateButton_Click);
-      // 
-      // tabControl
-      // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.tabControl.Controls.Add(this.runsTabPage);
-      this.tabControl.Controls.Add(this.modifiersTabPage);
-      this.tabControl.Location = new System.Drawing.Point(3, 26);
-      this.tabControl.Name = "tabControl";
-      this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(496, 318);
-      this.tabControl.TabIndex = 5;
-      // 
-      // runsTabPage
-      // 
-      this.runsTabPage.Controls.Add(this.runCollectionViewHost);
-      this.runsTabPage.Location = new System.Drawing.Point(4, 22);
-      this.runsTabPage.Name = "runsTabPage";
-      this.runsTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.runsTabPage.Size = new System.Drawing.Size(488, 292);
-      this.runsTabPage.TabIndex = 0;
-      this.runsTabPage.Text = "Runs";
-      this.runsTabPage.UseVisualStyleBackColor = true;
-      // 
-      // runCollectionViewHost
-      // 
-      this.runCollectionViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.runCollectionViewHost.Caption = "View";
-      this.runCollectionViewHost.Content = null;
-      this.runCollectionViewHost.Enabled = false;
-      this.runCollectionViewHost.Location = new System.Drawing.Point(6, 6);
-      this.runCollectionViewHost.Name = "runCollectionViewHost";
-      this.runCollectionViewHost.ReadOnly = false;
-      this.runCollectionViewHost.Size = new System.Drawing.Size(476, 280);
-      this.runCollectionViewHost.TabIndex = 0;
-      this.runCollectionViewHost.ViewsLabelVisible = true;
-      this.runCollectionViewHost.ViewType = null;
-      // 
-      // modifiersTabPage
-      // 
-      this.modifiersTabPage.Controls.Add(this.modifiersViewHost);
-      this.modifiersTabPage.Controls.Add(this.evaluateButton);
-      this.modifiersTabPage.Location = new System.Drawing.Point(4, 22);
-      this.modifiersTabPage.Name = "modifiersTabPage";
-      this.modifiersTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.modifiersTabPage.Size = new System.Drawing.Size(488, 292);
-      this.modifiersTabPage.TabIndex = 1;
-      this.modifiersTabPage.Text = "Modifiers";
-      this.modifiersTabPage.UseVisualStyleBackColor = true;
-      // 
-      // modifiersViewHost
-      // 
-      this.modifiersViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.modifiersViewHost.Caption = "View";
-      this.modifiersViewHost.Content = null;
-      this.modifiersViewHost.Enabled = false;
-      this.modifiersViewHost.Location = new System.Drawing.Point(6, 6);
-      this.modifiersViewHost.Name = "modifiersViewHost";
-      this.modifiersViewHost.ReadOnly = false;
-      this.modifiersViewHost.Size = new System.Drawing.Size(476, 254);
-      this.modifiersViewHost.TabIndex = 0;
-      this.modifiersViewHost.ViewsLabelVisible = true;
-      this.modifiersViewHost.ViewType = null;
-      // 
-      // RunCollectionModificationEvaluatorView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.Controls.Add(this.tabControl);
-      this.Name = "RunCollectionModificationEvaluatorView";
-      this.Size = new System.Drawing.Size(502, 347);
-      this.Controls.SetChildIndex(this.tabControl, 0);
-      this.Controls.SetChildIndex(this.infoLabel, 0);
-      this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.nameLabel, 0);
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.tabControl.ResumeLayout(false);
-      this.runsTabPage.ResumeLayout(false);
-      this.modifiersTabPage.ResumeLayout(false);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Button evaluateButton;
-    private System.Windows.Forms.TabControl tabControl;
-    private System.Windows.Forms.TabPage runsTabPage;
-    private MainForm.WindowsForms.ViewHost runCollectionViewHost;
-    private System.Windows.Forms.TabPage modifiersTabPage;
-    private MainForm.WindowsForms.ViewHost modifiersViewHost;
-  }
-}
Index: branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.cs
===================================================================
--- branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.cs	(revision 6784)
+++ 	(revision )
@@ -1,83 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Data;
-using System.Drawing;
-using System.Linq;
-using System.Text;
-using System.Windows.Forms;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Optimization.Views {
-
-  [View("RunCollection Calculator View")]
-  [Content(typeof(RunCollectionModificationEvaluator), IsDefaultView = true)]
-  public sealed partial class RunCollectionModificationEvaluatorView : NamedItemView {
-
-    public new RunCollectionModificationEvaluator Content {
-      get { return (RunCollectionModificationEvaluator)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public RunCollectionModificationEvaluatorView() {
-      InitializeComponent();
-    }
-
-    protected override void DeregisterContentEvents() {
-      Content.RunCollectionParameter.ValueChanged -= new EventHandler(RunCollection_Changed);
-      Content.ModifiersParameter.ValueChanged -= new EventHandler(Modifiers_Changed);
-      base.DeregisterContentEvents();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.RunCollectionParameter.ValueChanged += new EventHandler(RunCollection_Changed);
-      Content.ModifiersParameter.ValueChanged += new EventHandler(Modifiers_Changed);
-    }
-
-    #region Event Handlers (Content)
-    private void RunCollection_Changed(object sender, EventArgs args) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(RunCollection_Changed), sender, args);
-      else
-        runCollectionViewHost.Content = Content.RunCollection;
-    }
-    private void Modifiers_Changed(object sender, EventArgs args) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Modifiers_Changed), sender, args);
-      else
-        modifiersViewHost.Content = Content.Modifiers;
-    }
-    #endregion
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        runCollectionViewHost.Content = null;
-        modifiersViewHost.Content = null;
-      } else {
-        runCollectionViewHost.Content = Content.RunCollection;
-        modifiersViewHost.Content = Content.Modifiers;
-      }
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      evaluateButton.Enabled = Content != null;
-    }
-
-    #region Event Handlers (child controls)
-    private void evaluateButton_Click(object sender, EventArgs e) {
-      evaluateButton.Enabled = false;
-      var worker = new BackgroundWorker();
-      worker.DoWork += (s, a) => Content.Evaluate();
-      worker.RunWorkerCompleted += (s, a) => { evaluateButton.Enabled = Content != null; };
-      worker.RunWorkerAsync();
-    }        
-    #endregion
-
-  }
-}