Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeMove.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeMove.cs	(revision 6773)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeMove.cs	(revision 6787)
@@ -29,4 +29,5 @@
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
 using HeuristicLab.Optimization;
+using System;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Potvin {
@@ -81,4 +82,5 @@
     #region IVRPMove Members
 
+    [ThreadStatic]
     private static PotvinPDExchangeMoveEvaluator moveEvaluator;
     public VRPMoveEvaluator GetMoveEvaluator() {
@@ -89,4 +91,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDExchangeMoveMaker moveMaker; 
     public VRPMoveMaker GetMoveMaker() {
@@ -97,4 +100,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDExchangeMoveTabuMaker tabuMaker;
     public ITabuMaker GetTabuMaker() {
@@ -105,4 +109,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDExchangeTabuCriterion tabuChecker;
     public ITabuChecker GetTabuChecker() {
@@ -115,4 +120,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDExchangeTabuCriterion softTabuChecker;
     public ITabuChecker GetSoftTabuChecker() {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeMove.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeMove.cs	(revision 6773)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeMove.cs	(revision 6787)
@@ -29,4 +29,5 @@
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
 using HeuristicLab.Optimization;
+using System;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Potvin {
@@ -71,4 +72,5 @@
     #region IVRPMove Members
 
+    [ThreadStatic]
     private static PotvinPDRearrangeMoveEvaluator moveEvaluator;
     public VRPMoveEvaluator GetMoveEvaluator() {
@@ -79,4 +81,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDRearrangeMoveMaker moveMaker;
     public VRPMoveMaker GetMoveMaker() {
@@ -87,4 +90,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDRearrangeMoveTabuMaker tabuMaker;
     public ITabuMaker GetTabuMaker() {
@@ -95,4 +99,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDRearrangeTabuCriterion tabuChecker;
     public ITabuChecker GetTabuChecker() {
@@ -105,4 +110,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDRearrangeTabuCriterion softTabuChecker;
     public ITabuChecker GetSoftTabuChecker() {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftMove.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftMove.cs	(revision 6773)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftMove.cs	(revision 6787)
@@ -29,4 +29,5 @@
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
 using HeuristicLab.Optimization;
+using System;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Potvin {
@@ -76,4 +77,5 @@
     #region IVRPMove Members
 
+    [ThreadStatic]
     private static PotvinPDShiftMoveEvaluator moveEvaluator;
     public VRPMoveEvaluator GetMoveEvaluator() {
@@ -84,4 +86,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDShiftMoveMaker moveMaker;
     public VRPMoveMaker GetMoveMaker() {
@@ -92,4 +95,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDShiftMoveTabuMaker tabuMaker;
     public ITabuMaker GetTabuMaker() {
@@ -100,4 +104,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDShiftTabuCriterion tabuChecker;
     public ITabuChecker GetTabuChecker() {
@@ -110,4 +115,5 @@
     }
 
+    [ThreadStatic]
     private static PotvinPDShiftTabuCriterion softTabuChecker;
     public ITabuChecker GetSoftTabuChecker() {